import { Map, List } from "immutable";
export declare type StateTreeNode = {
    reducerKey: string;
    pReducerKey: string | null | undefined;
    children: Map<string, any>;
};
export declare type StateTreeDictItem = {
    reducerKey: {
        path: List<string>;
        isObsolete: boolean;
    };
};
export declare type StateTreeDict = Map<string, Map<string, any>>;
export declare type StateTree = Map<string, Map<string, any>>;
export declare type ArenaState = {
    audienceSagaTask: object | null | undefined;
    propsLock: boolean;
    stateTree: StateTree;
    stateTreeDict: StateTreeDict;
};
export declare type RootState = {
    arena: ArenaState;
    [key: string]: any;
};
