import { bindActionCreators } from "redux";
import { connect } from "react-redux";
import actions from "./actions";
import BundleComponent from "./BundleComponent";
export default function curtainConnect(reducerKey, clearCurtain) {
    var mapDispatchToProps = function (dispatch) {
        return bindActionCreators(actions, dispatch);
    };
    var mapStateToProps = function (state) {
        return {
            PlayingScene: state[reducerKey].PlayingScene,
            curSceneBundle: state[reducerKey].curSceneBundle,
            reduxInfo: state[reducerKey].reduxInfo,
            mutableObj: state[reducerKey].mutableObj,
            clearCurtain: clearCurtain
        };
    };
    var ConnectedComponent = connect(mapStateToProps, mapDispatchToProps)(BundleComponent);
    ConnectedComponent.displayName = "curtainConnect({reducerKey:" + reducerKey + "})";
    return ConnectedComponent;
}
