var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import { ArenaScene } from "../hocs";
import { defaultPropsPicker, defaultActions, defaultReducerCreator } from "./autoFill";
function bundleToElement(bundle, props, extraProps) {
    var newBundle = Object.assign({
        propsPicker: defaultPropsPicker,
        actions: defaultActions,
        reducer: defaultReducerCreator(bundle.state)
    }, bundle);
    return (React.createElement(ArenaScene, __assign({ sceneBundle: newBundle, sceneProps: props }, extraProps)));
}
export default bundleToElement;
