import { ActionCreatorsMapObject } from "redux";
import { CurtainLoadSceneAction, CurtainState, ReducerDict, SceneBundle } from "../../core";
export declare type State = {
    loadedPromise: Promise<null>;
};
export declare type BaseProps = CurtainState<{}> & {
    clearCurtain: () => void;
};
export declare type ConnectedProps = BaseProps & Props & {
    curtainLoadScene: CurtainLoadScene<{}, {}, {}, {}>;
};
export declare type Props = {
    arenaReducerDict: ReducerDict;
    sceneBundle: SceneBundle<{}, {}, {}, {}>;
    sceneProps: any;
};
export declare type CurtainLoadScene<P extends PP, S, A extends ActionCreatorsMapObject, PP> = (arenaReducerDict: ReducerDict, sceneBundle: SceneBundle<P, S, A, PP>, isInitial: any, loadedCb: () => void) => CurtainLoadSceneAction<P, S, A, PP>;
