/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import { ActionCreatorsMapObject } from "redux";
import { ReducerDictOverriderProps } from "./types";
export default class ReducerDictOverrider extends React.Component<ReducerDictOverriderProps> {
    static childContextTypes: {
        arenaReducerDict: PropTypes.Requireable<any>;
    };
    getChildContext(): {
        arenaReducerDict: {
            [key: string]: {
                reducerKey: string;
                vReducerKey: string | null | undefined;
                actions: ActionCreatorsMapObject;
            };
        };
    };
    render(): React.ReactElement<{}> | (string & React.ReactElement<{}>) | (number & React.ReactElement<{}>) | (true & React.ReactElement<{}>) | (false & React.ReactElement<{}>) | (React.ReactElement<any> & React.ReactElement<{}>) | ((string | number | boolean | any[] | React.ReactElement<any>)[] & React.ReactElement<{}>) | (React.ReactPortal & React.ReactElement<{}>);
}
