var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var effects_1 = require("redux-saga/effects");
var react_redux_1 = require("react-redux");
var enhancedRedux_1 = require("../enhancedRedux");
var sceneReduxSaga_1 = require("./sceneReduxSaga");
var ActionTypes_1 = require("../ActionTypes");
function applySceneBundle(_a) {
    var isInitial = _a.isInitial, arenaReducerDict = _a.arenaReducerDict, sceneBundle = _a.sceneBundle, loadedCb = _a.loadedCb;
    var arenaCurtainReducerKey, curtainState, curSceneBundle, reduxInfo, OldPlayingScene, mutableObj, newReduxInfo, newMutableObj, propsPicker, PlayingScene, displayName, newArenaState, arenaStore;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                arenaCurtainReducerKey = arenaReducerDict._arenaCurtain.reducerKey;
                return [4 /*yield*/, effects_1.select(function (state) { return state[arenaCurtainReducerKey]; })];
            case 1:
                curtainState = _b.sent();
                curSceneBundle = curtainState.curSceneBundle, reduxInfo = curtainState.reduxInfo, OldPlayingScene = curtainState.PlayingScene, mutableObj = curtainState.mutableObj;
                mutableObj.isObsolete = true;
                if (!isInitial) return [3 /*break*/, 3];
                return [5 /*yield**/, __values(sceneReduxSaga_1.sceneApplyRedux({
                        arenaReducerDict: arenaReducerDict,
                        state: sceneBundle.state,
                        saga: sceneBundle.saga,
                        actions: sceneBundle.actions,
                        reducer: sceneBundle.reducer,
                        options: sceneBundle.options
                    }))];
            case 2:
                newReduxInfo = _b.sent();
                return [3 /*break*/, 5];
            case 3: return [5 /*yield**/, __values(sceneReduxSaga_1.sceneUpdateRedux({
                    arenaReducerDict: arenaReducerDict,
                    state: sceneBundle.state,
                    saga: sceneBundle.saga,
                    actions: sceneBundle.actions,
                    reducer: sceneBundle.reducer,
                    options: sceneBundle.options,
                    curSceneBundle: curSceneBundle,
                    reduxInfo: reduxInfo
                }))];
            case 4:
                newReduxInfo = _b.sent();
                _b.label = 5;
            case 5:
                newMutableObj = { isObsolete: false };
                return [4 /*yield*/, effects_1.put({
                        type: ActionTypes_1.default.ARENA_CURTAIN_SET_STATE,
                        _reducerKey: arenaCurtainReducerKey,
                        state: {
                            reduxInfo: newReduxInfo,
                            mutableObj: newMutableObj
                        }
                    })];
            case 6:
                _b.sent();
                propsPicker = enhancedRedux_1.createPropsPicker(sceneBundle.propsPicker, newReduxInfo, newMutableObj);
                PlayingScene = react_redux_1.connect(propsPicker)(sceneBundle.Component);
                displayName = sceneBundle.Component.displayName ||
                    sceneBundle.Component.name ||
                    "Unknown";
                PlayingScene.displayName = "SceneConnect({reducerKey:" + newReduxInfo.reducerKey + ",Component:" + displayName + "})";
                newArenaState = {
                    PlayingScene: PlayingScene,
                    curSceneBundle: sceneBundle
                };
                return [4 /*yield*/, effects_1.put({
                        type: ActionTypes_1.default.ARENA_CURTAIN_SET_STATE,
                        _reducerKey: arenaCurtainReducerKey,
                        state: newArenaState
                    })];
            case 7:
                _b.sent();
                loadedCb();
                if (!(reduxInfo != null &&
                    newReduxInfo.reducerKey !== reduxInfo.reducerKey &&
                    reduxInfo.reducerKey != null)) return [3 /*break*/, 11];
                return [4 /*yield*/, effects_1.getContext("store")];
            case 8:
                arenaStore = _b.sent();
                return [4 /*yield*/, effects_1.put({
                        type: ActionTypes_1.default.ARENA_STATETREE_NODE_DISABLE,
                        reducerKey: reduxInfo.reducerKey
                    })];
            case 9:
                _b.sent();
                arenaStore.removeSingleReducer(reduxInfo.reducerKey);
                return [4 /*yield*/, effects_1.put({
                        type: ActionTypes_1.default.ARENA_STATETREE_NODE_DELETE,
                        reducerKey: reduxInfo.reducerKey
                    })];
            case 10:
                _b.sent();
                _b.label = 11;
            case 11: return [2 /*return*/];
        }
    });
}
exports.applySceneBundle = applySceneBundle;
