Object.defineProperty(exports, "__esModule", { value: true });
var redux_1 = require("redux");
var react_redux_1 = require("react-redux");
var actions_1 = require("./actions");
var BundleComponent_1 = require("./BundleComponent");
function curtainConnect(reducerKey, clearCurtain) {
    var mapDispatchToProps = function (dispatch) {
        return redux_1.bindActionCreators(actions_1.default, dispatch);
    };
    var mapStateToProps = function (state) {
        return {
            PlayingScene: state[reducerKey].PlayingScene,
            curSceneBundle: state[reducerKey].curSceneBundle,
            reduxInfo: state[reducerKey].reduxInfo,
            mutableObj: state[reducerKey].mutableObj,
            clearCurtain: clearCurtain
        };
    };
    var ConnectedComponent = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(BundleComponent_1.default);
    ConnectedComponent.displayName = "curtainConnect({reducerKey:" + reducerKey + "})";
    return ConnectedComponent;
}
exports.default = curtainConnect;
