var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var hocs_1 = require("../hocs");
var autoFill_1 = require("./autoFill");
function bundleToComponent(bundle, extraProps) {
    var newBundle = Object.assign({
        propsPicker: autoFill_1.defaultPropsPicker,
        actions: autoFill_1.defaultActions,
        reducer: autoFill_1.defaultReducerCreator(bundle.state)
    }, bundle);
    var WrapperClass = function (props) { return (React.createElement(hocs_1.ArenaScene, __assign({ sceneBundle: newBundle, sceneProps: props }, extraProps))); };
    WrapperClass.displayName = "ScenePropsProxy";
    return WrapperClass;
}
exports.default = bundleToComponent;
