/// <reference types="react" />
import { SFC } from "react";
import { ActionCreatorsMapObject } from "redux";
import { SceneBundle, ReducerDict, SceneBundleOptions } from "../../types";
export declare type CurtainReduxInfo<S> = {
    reducerKey: string;
    state?: S | null | undefined;
    origArenaReducerDict: ReducerDict;
    actions: ActionCreatorsMapObject | null | undefined;
    options: SceneBundleOptions;
    saga: (...params: any[]) => any;
    bindedActions: ActionCreatorsMapObject;
    arenaReducerDict: ReducerDict;
};
export declare type CurtainMutableObj = {
    isObsolete: boolean;
};
export declare type CurtainState<P extends PP, S = {}, A extends ActionCreatorsMapObject = {}, PP = {}> = {
    PlayingScene: SFC<P> | null | undefined;
    curSceneBundle: SceneBundle<P, S, A, PP> | null | undefined;
    reduxInfo: CurtainReduxInfo<S> | null | undefined;
    mutableObj: CurtainMutableObj;
};
